#!/bin/sh
# Built on TCL v4.2.1
# Required extensions:
#	Xlibs
#	qt-4.x-doc
#	 qt-4.x-dev
#	  qt-4.x-base
#	   Xorg-7.6-lib
#	   fontconfig
#	    expat2
#	   glib2
#	    libffi
#	   libssl-0.9.8
#	  fontconfig-dev
#	   expat2-dev
#	  glib2-dev
#	   libffi-dev
#	  openssl-1.0.0-dev
#	  compiletc
#	   bison
#	   diffutils
#	   file
#	   findutils
#	   flex
#	   gawk
#	   gcc
#	    gcc_libs
#	    binutils
#	    libmpc
#	     mpfr
#	      gmp
#	   grep
#	   m4
#	   make
#	   patch
#	   pkg-config
#	    popt
#	   sed
#	   e2fsprogs_base-dev
#	   eglibc_base-dev
#	   fltk_base-dev
#	   freetype_base-dev
#	   gcc_base-dev
#	   imlib2_base-dev
#	   jpeg_base-dev
#	   libpng_base-dev
#	   libsysfs_base-dev
#	   linux-3.0.1_api_headers
#	   util-linux_base-dev
#	   zlib_base-dev
#	 qt-4.x-extended
#	 qt-4.x-sql
#	  sqlite3
#	 qt-4.x-webkit
#	 qt-4.x-xml
#	squashfs-tools-4.x
#	tar
#	phonon-dev
#	 phonon
#	  qt-4.x-dbus
#	   dbus
#	qt-4.x-designer
#	 qt-4.x-script
#	qt-4.x-htmldoc
#	qt-4.x-opengl
#	qt-4.x-qml
#	qt-4.x-qtconfig
#	 qt-4.x-qt3support
#	python-dev
#	 sqlite3-dev
#	 tk-dev
#	  tk
#	   tcl
#	  tcl-dev
#	 bzip2-dev
#	  bzip2-lib
#	  bzip2
#	 python
#	sip
#	dbus-python
#	 dbus-glib
#	dbus-dev
#	Xorg-7.6-dev

getTime.sh

installExtension() {
	if [ ! -e /usr/local/tce.installed/$1 ]; then
		echo "Installing "$1" ..."
		
		if [ -e /etc/sysconfig/tcedir/optional/$1.tcz ]; then
			tce-load -i $1
		else
			tce-load -wi $1
		fi
		
		[ ! -e /usr/local/tce.installed/$1 ] && echo "Error: Extension "$1" not installed! Aborting" && exit
	fi
}
	
createExtension() {
	mksquashfs $1 $1.tcz -noappend
	[ ! -e $1.tcz ] && echo "Error: "$1".tcz not created! Aborting" && exit
}
	
unpackSrc() {
	#unpack source
	if [ -e $1.tar.bz2 ]; then
		tar -jxf $1.tar.bz2
	elif [ -e $1.tb2 ]; then
		tar -jxf $1.tb2
	elif [ -e $1.tbz ]; then
		tar -jxf $1.tbz
	elif [ -e $1.tar.gz ]; then
		tar -zxf $1.tar.gz
	elif [ -e $1.tgz ]; then
		tar -zxf $1.tgz
	elif [ -e $1.tar.xz ]; then
		tar -Jxf $1.tar.xz
	elif [ -e $1.txz ]; then
		tar -Jxf $1.txz
	elif [ -e $1.tar.lzma ]; then
		tar -xf $1.tar.lzma --lzma
	elif [ -e $1.tlz ]; then
		tar -xf $1.tlz --lzma
	else
		echo "Source "$1" not found! Aborting" && exit
	fi
}

# Install these extensions automagically
export EXTS="Xlibs
qt-4.x-doc
squashfs-tools-4.x
tar
phonon-dev
qt-4.x-designer
qt-4.x-htmldoc
qt-4.x-opengl
qt-4.x-qml
qt-4.x-qtconfig
python-dev
sip
dbus-python-2.7
dbus-dev
Xorg-7.6-dev"

export CFLAGS="-march=i486 -mtune=i686 -Os -pipe"
export CXXFLAGS=$CFLAGS" -fno-exceptions -fno-rtti"
export PKG_CONFIG_PATH=/usr/local/lib/pkgconfig:/usr/lib/pkgconfig
export QMAKESPEC=/usr/local/mkspecs/linux-g++
export EXTNAME="pyqt"
export VER="-4.9.1"
export DESTDIR=`pwd`/$EXTNAME
export PKGNAME="PyQt-x11-gpl"$VER

for f in $EXTS; do
	installExtension $f
done

unpackSrc $PKGNAME

mkdir $EXTNAME

cd $PKGNAME

python configure.py --confirm-license && make && make install INSTALL_ROOT=$DESTDIR || exit

cd $DESTDIR

sudo strip --strip-unneeded usr/local/bin/*
sudo strip -g usr/local/plugins/designer/*

cd ..

createExtension $EXTNAME

rm -rf $EXTNAME $PKGNAME

# Create extension support files and test
installExtension "submitqc4"

submitqc4
